Subject: [bug#38015] Emacs in multiple profiles

From: Chris Marusich <[email-masked]>
Date: Mon, 11 Nov 2019 21:14:24 -0800

Maxim Cournoyer <[email-masked]> writes:

> [+ guix-patches]
>
> Hello!
>
> Pierre Neidhardt <[email-masked]> writes:
>
>> I've reviewed and tested the patch:
>>
>> - review: 5/5 stars :D
>> - test: pass!
>>
>> I've tested the following:
>>
>> $ /home/ambrevar/projects/guix/pre-inst-env guix package -i emacs-2048-game emacs -p ~/temp/foo
>> $ cd ~/temp
>> $ env -i $(which bash) --login --noprofile --norc
>> bash-5.0$ /run/current-system/profile/bin/env DISPLAY=:1 emacs
>>
>>
>> Content of *Messages*:
>>
>> Loading /gnu/store/ghdkfqnvrxipp4ikakags5rl7flywb72-profile/share/emacs/site-lisp/guix.d/2048-game-20151026.1233/2048-game-autoloads.el (source)...done
>> For information about GNU Emacs and the GNU system, type C-h C-a.
>>
>>
>> And 
>>
>> M-x 2048-game RET
>>
>> works!
>
> I'm glad it works and fixes your use case :-).
>
>> Can we merge this on master?  We have some 700 emacs packages that are
>> going to be rebuilt, but it's rather light for the build farm.  What do
>> you think?
>
> I'm not worried about the 700 Emacs packages that will need to be
> rebuild, but I'd prefer to take a bit of time to let people comment on
> this non-trivial change.
>
> The new behavior (of not always loading stuff from the user profile and
> system profiles) is different and may break the flow of some people.
>
> For one, I think restarting my Emacs server (started at login) won't be
> enough to discover newly installed packages to my profile.  Emacs-Magit
> may also be impacted, I haven't reviewed if it uses that autoload
> function from site-start.el.
>
> Refreshing an environment variable value for a process (such as Emacs)
> is not as convenient as re-scanning a directory.
>
> I'll let some time pass (2 weeks), and if nobody objects, I'll merge it
> to master.
>
> Thanks for the review!
>
> Maxim

I'd like to test this, but I can't build Guix, so I can't test it.  I
don't know when I'll be able to test it, since I don't know when I'll be
able to build Guix:

"configure: error: Guix requires zlib."
https://debbugs.gnu.org/cgi/bugreport.cgi?bug=38175

Is there a specific commit that you can recommend I use when applying
the patches?  Perhaps one you built successfully yourself?  If you could
also give me your currently installed Guix version so I can "guix pull"
to it, that would be helpful.

-- 
Chris